100 :
110 REMark *************************************************************
120 REMark * The following two lines instruct Turbo how to compile EX1 *
130 REMark *************************************************************
140 :
150 TURBO_objfil 'ram1_EX1_TASK':TURBO_taskn 'EX1 v2.3':TURBO_objdat 100
160 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
170 :
180 REMark EX1_bas v2.3
190 REMark 24 DEC 01
200 :
210 IF MODE%=8:MODE 4
220 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
230 :
240 REMark **************************************
250 REMark * wch% is used by M_SETUP, see later *
260 REMark **************************************
270 :
280 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
290 :
300 REMark **********************************************************************
310 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
320 REMark * and sets wd(r), the address(es) of window definition(s)            *
330 REMark **********************************************************************
340 :
350 REMark                **************************************
360 OPEN#4,con:    REMark * ex1 - for use in writing etc       *
370 DIM str$(0,32):REMark * ex1 - string to contain directory  *
380 REMark                **************************************
390 :
400 REMark                            **************************************
410 wwd=M_SETUP(#wch%,wd(0),0):REMark * To produce the working definition  *
420 push:          REMark             *      - sets a null menu  -         *
430 REMark                            **************************************
440 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
450 REMark ************************************************************
460 REMark * We must set a primary window here if this is COMPILED .  *
470 REMark * (PRPOS can be thought of as PRimary POSitioned)          *
480 REMark * If this is not COMPILED, BOUTL has set #0 as primary, so *
490 REMark * the window here must instead be "pulled down".           *
500 REMark ************************************************************
510 REMark                             *********************************
520 SET_CHANNEL#4,SWIN(2,0,wwd):REMark *  sets #4                      *
530 D_LDRW 16*65536+3,wwd:REMark       *  makes COPY unavailable       *
540 prap:          REMark              *  prints in application window *
550 REMark                             *********************************
560 :
570 REMark *******************************************************
580 REMark * This is the repeat loop for reading the pointer and *
590 REMark * taking apropriate action                            *
600 REMark *******************************************************
610 :
620 REPeat lp
630  k=WRPTR(wwd):REMark k indicates whether loose item, event or application
640  r=255&&get_x%(k)
650  SELect ON r
660   =255:REMark loose items
670     IF do_loose%(get_y%(k)):EXIT lp
680   =254:REMark event
690     IF do_event%(get_y%(k)):EXIT lp
700   =REMAINDER :REMark application window k
710     do_app r,get_y%(k)
720  END SELect
730 END REPeat lp
740 STOP
750 :
760 DEFine PROCedure finish
770  CLS#4:PRINT#4,"ENDED":SUSPEND_TASK 75:BUNST wwd:CLOS chid:REMark *  the window is removed *
780  CLOSE#4:
790  BRECHP:REMark *  all ALCHPd space returned to the heap *
800 END DEFine
810 :
820 DEFine FuNction do_loose%(num)
830  REMark *********************************************
840  REMark * routine to do loose items                 *
850  REMark * this returns 1 for "finished" else 0      *
860  REMark *  the four loose items are 0 = move sprite *
870  REMark *                           1 = ESC         *
880  REMark *                           2 = DISPLAY     *
890  REMark *                           3 = COPY        *
900 REMark **********************************************
910  LOCal ov%,nym
920  ov%=0:nym=num:REMark Don't use parameter for SELect
930  SELect ON nym
940   =1:finish:ov%=1
950   =0:mve1
960  REMark ***************************************************
970  REMark *  set_st puts the directory of FLP1 to str$      *
980  REMark *  D_LDRW 3 & 2 set DISPLAY and COPY to available *
990  REMark *  BWRSET redraws the window with the directory   *
1000  REMark ***************************************************
1010 :
1020   =2:set_st:D_LDRW 3,wwd:D_LDRW 2,wwd:BWRSET wwd
1030 :
1040  REMark ***************************************************
1050  REMark *  do_cop copies selected files                   *
1060  REMark *  push sets a null menu                          *
1070  REMark *  DEALLOCATE adr returns space used for the menu *
1080  REMark ***************************************************
1090 :
1100   =3:do_cop:push:DEALLOCATE adr:REMark to copy str$ files
1110   =REMAINDER :ov%=1
1120  END SELect
1130  RETurn ov%
1140 END DEFine
1150 :
1160 DEFine FuNction do_event%(num%)
1170  REMark carry out event
1180  REMark only move and escape now
1190  LOCal ov%
1200  ov%=0
1210  IF 2&&num%:finish:ov%=1
1220  IF 8&&num%:mve1
1230  RETurn ov%
1240 END DEFine
1250 :
1260 DEFine PROCedure do_app(wind%,num%)
1270  REMark *********************************
1280  REMark * to do the menu item no num%   *
1290  REMark * in window number wind%        *
1300  REMark * no action need be taken here  *
1310  REMark *********************************
1320 :
1330 END DEFine
1340 :
1350 DEFine PROCedure mve1
1360  REMark to move window
1370  BCHWIN wwd
1380  D_LDRW 0,wwd
1390  SET_CHANNEL#4,SWIN(2,0,wwd)
1400 END DEFine
1410 :
1420 DEFine PROCedure prap
1430  REMark ******************************************
1440  REMark * this overwrites the application window *
1450  REMark * which now has a null menu              *
1460  REMark ******************************************
1470 :
1480  USE 4:CLS:PAPER BLACK%:OVER 0:INK WHITE%
1490  AT 2,2:PRINT "DISPLAY:":AT 5,2:PRINT "COPY:"
1500  INK GREEN%
1510  AT 3,3:PRINT "Shows files from flp1_"
1520  AT 6,3:PRINT "Copies selected files to ram1_"
1530  USE
1540 END DEFine
1550 :
1560 DEFine PROCedure set_st
1570  REMark * ex1 - to put flp1_ directory to application via str$ *
1580  LOCal x,k%,ch%,a$(52),lp,lp1,z,m%,top,pos
1590  ch%=N_CHAN%
1600  lp=DEVICE_STATUS(2,"ram1_dd"):lp=(lp=-8)+(lp<0)*2+(lp>=0)*4
1610  SELect ON lp
1620   =3:DELETE "ram1_dd"
1630   =4:REMark OK
1640   =REMAINDER : finish:STOP
1650  END SELect
1660  OPEN_NEW#ch%,"ram1_dd":REMark The quotation marks are needed for Turbo
1670  IF DEVICE_STATUS(1,"flp1_")<0:finish:CLOSE#ch%:STOP
1680  DIR#ch%,"flp1_" :REMark The quotation marks are needed to stop Turbo taking flp1_ as 0
1690  SET_POSITION#ch%,0:k%=0:USE ch%:m%=0
1700  INPUT a$:INPUT a$:REMark Step past Name and Status
1705  pos=POSITION(#ch%)
1710  REPeat lp
1720   IF EOF(#ch%):EXIT lp
1730   INPUT a$:IF "->" INSTR a$:NEXT lp
1740   k%=k%+1:m%=max%(m%,LEN(a$))
1750  END REPeat lp
1760  m%=ev%(m%):REMark round up to even
1770  REMark k%=number of files:m%=max length of name
1780  DIM str$(k%,m%)
1790  SET_POSITION#ch%,pos:x=1
1800  REPeat lp1
1810   IF EOF(#ch%):EXIT lp1
1820   INPUT a$:IF "->" INSTR a$:NEXT lp1
1830   str$(x)=a$:x=x+1
1840  END REPeat lp1
1850  USE:CLOSE#ch%
1860 :
1870  REMark **************************************
1880  REMark * adr -> the space used for the menu *
1890  REMark **************************************
1900 :
1910  adr=set_ap(str$,0,wwd)
1920 END DEFine
1930 :
1940 DEFine PROCedure do_cop
1950  REMark                     **********************************
1960  REMark                     * To copy marked files to ram1_  *
1970  LOCal x,ad,ae,k%
1980  ad=addr_appw(0,wwd):REMark *  address of status area        *
1990  ae=AD_SUB(0,1,wwd): REMark *  address of app. window        *
2000  k%=PEEK_W(ae+146):  REMark *  no of rows = items            *
2010  FOR x=1 TO k%
2020                      REMark *  ad+x-1 is 128 for 'selected'  *
2030  REMark                     **********************************
2040   IF PEEK(ad+x-1):Cop_Fl str$(x)
2050  END FOR x
2060  POKE_L ae+20,0:POKE_L ae+28,0:REMark * to stop menu items  *
2070  D_LDRW 16*65536+3,wwd:prap
2080 END DEFine
2090 :
2100 DEFine PROCedure push
2110  REMark *  to set a null menu *
2120  LOCal ae
2130 :
2140  REMark                     **************************
2150  ae=AD_SUB(0,1,wwd): REMark * address of app. window *
2160  POKE_L ae+70,0:REMark      * no y-control block     *
2170  POKE_L ae+28,0:REMark      * no control routine     *
2180  POKE_L ae+32,0:REMark      * no control sections    *
2190  POKE_L ae+20,0:REMark      * no draw routine        *
2200  POKE_L ae+152,0:POKE_L ae+156,0:POKE_L ae+168,0
2210  POKE_L ae+144,0:REMark     * no rows OR cols        *
2220  POKE_L ae+100,0:REMark     * no status block        *
2230  POKE_W ae+150,6:REMark     * room for arrows        *
2240  REMark                     **************************
2250 :
2260  POKE_W ae+94,GREEN%:POKE_W ae+94+4,GREEN%:REMark * arrows *
2270 END DEFine
2280 :
2290 DEFine PROCedure Cop_Fl(a$)
2300  LOCal st
2310  st=DEVICE_STATUS(2,"ram1_"&a$)
2320  IF st<0:RETurn
2330  IF st=-8:DELETE "ram1_"&a$
2340  COPY "flp1_"&a$,"ram1_"&a$
2350 END DEFine
2360 :
2370 REMark ********************************************************
2380 REMark * The following DATA lines contain all the             *
2390 REMark * information needed to set up the windows in EX1.     *
2400 REMark * This includes the window sizes, the colours, and     *
2410 REMark * sprites wanted. It also contains the sprites, blobs, *
2420 REMark * or patterns themselves. All this is unravelled and   *
2430 REMark * set in the window definitions by Set_Win.            *
2440 REMark ********************************************************
2450 :
19600 DATA 2244
19601 DATA 20,17747,17162,17481,21328,19521,22794,17231
19602 DATA 20569,2592,2570,1888,1446,1780,1,6
19603 DATA 150,256,8192,5,5,2,2,0
19604 DATA 12,0,28,0,44,0,0,8224
19605 DATA 0,20560,0,8224,0,0,0,8224
19606 DATA 0,28784,0,-1800,0,28784,0,8224
19607 DATA 0,256,16384,9,7,4,3,0
19608 DATA 12,0,36,0,0,0,0,2056
19609 DATA 0,5140,0,8738,0,5140,0,2056
19610 DATA 0,0,0,2056,0,7196,0,15934
19611 DATA 0,32639,0,15934,0,7196,0,2056
19612 DATA 0,256,8192,41,26,20,1,0
19613 DATA 12,0,320,0,628,0,0,10794
19614 DATA 0,0,0,771,-1,5140,32639,-7968
19615 DATA 0,1031,255,-27500,-32513,4336,0,2063
19616 DATA 255,21973,255,2296,0,4382,19125,8931
19617 DATA 10710,17596,0,4127,255,5367,255,1276
19618 DATA 0,9023,4863,5367,9471,25342,0,9279
19619 DATA -24833,5367,15615,-27906,0,9279,-27905,5367
19620 DATA 9471,-27906,0,9023,4863,5367,9471,25342
19621 DATA 0,16511,255,5367,255,511,0,16511
19622 DATA 255,5367,255,511,0,21611,-511,5367
19623 DATA 16320,-27285,0,10295,-32131,5239,8287,-30090
19624 DATA 0,10295,17595,8803,4462,2806,0,10295
19625 DATA 10455,8803,2677,2806,0,4127,4335,8803
19626 DATA 1147,1276,0,4127,14535,8931,3825,1276
19627 DATA 0,4127,255,16833,255,1276,0,2063
19628 DATA 255,-32640,-32513,2296,0,1031,255,-32640
19629 DATA -32513,4336,0,515,511,0,16511,8416
19630 DATA 0,257,766,0,8255,16576,0,0
19631 DATA -32002,0,8255,-32640,0,0,31868,0
19632 DATA 7967,0,0,0,0,0,0,0
19633 DATA 0,771,-1,15934,32639,-7968,0,1799
19634 DATA -1,-25444,-1,-3856,0,3855,-1,-8739
19635 DATA -1,-1800,0,7967,-1,-1,-1,-772
19636 DATA 0,16191,-1,-1,-1,-258,0,16191
19637 DATA -1,-1,-1,-258,0,32639,-1,-1
19638 DATA -1,-1,0,32639,-1,-1,-1,-1
19639 DATA 0,32639,-1,-1,-1,-1,0,32639
19640 DATA -1,-1,-1,-1,0,-1,-1,-1
19641 DATA -1,-1,-32640,-1,-1,-1,-1,-1
19642 DATA -32640,-1,-1,-1,-1,-1,-32640,32639
19643 DATA -1,-1,-1,-1,0,32639,-1,-2057
19644 DATA -1,-1,0,32639,-1,-2057,-1,-1
19645 DATA 0,16191,-1,-2057,-1,-258,0,16191
19646 DATA -1,-2057,-1,-258,0,16191,-1,-7197
19647 DATA -1,-258,0,7967,-1,-15935,-1,-772
19648 DATA 0,3855,-1,-15935,-1,-1800,0,1799
19649 DATA -1,-32640,-1,-3856,0,771,-1,0
19650 DATA 32639,-7968,0,257,-1,0,32639,-16192
19651 DATA 0,0,-258,0,16191,-32640,0,0
19652 DATA 31868,0,7967,0,0,256,16384,41
19653 DATA 26,20,1,0,12,0,320,0
19654 DATA 0,0,0,10794,0,0,0,0
19655 DATA 257,-32612,-16192,0,0,0,257,21973
19656 DATA 16576,0,0,0,515,21973,8416,0
19657 DATA 0,0,515,-23965,-24480,0,0,0
19658 DATA 515,5367,8416,0,0,0,515,-18697
19659 DATA -24352,0,0,0,515,-10761,-24352,0
19660 DATA 0,0,1031,-10761,-28432,0,0,0
19661 DATA 1031,-18697,-28432,0,0,0,515,5367
19662 DATA 8416,0,0,0,515,5367,8416,0
19663 DATA 0,0,515,-2284,-24480,0,0,0
19664 DATA 515,21942,8416,0,0,0,257,21942
19665 DATA 16576,0,0,0,257,25514,16576,0
19666 DATA 0,0,257,25506,16576,0,0,0
19667 DATA 257,-7390,-16320,0,0,0,257,8931
19668 DATA 16576,0,0,0,257,8931,16576,0
19669 DATA 0,0,0,-15935,-32640,0,0,0
19670 DATA 0,-15935,-32640,0,0,0,0,-15935
19671 DATA -32640,0,0,0,0,16705,0,0
19672 DATA 0,0,0,16705,0,0,0,0
19673 DATA 0,0,0,0,0,0,257,-16706
19674 DATA -16192,0,0,0,771,-8739,-7968,0
19675 DATA 0,0,771,-1,-7968,0,0,0
19676 DATA 1799,-1,-3856,0,0,0,1799,-1
19677 DATA -3856,0,0,0,1799,-1,-3856,0
19678 DATA 0,0,1799,-1,-3856,0,0,0
19679 DATA 1799,-1,-3856,0,0,0,3855,-1
19680 DATA -1800,0,0,0,3855,-1,-1800,0
19681 DATA 0,0,1799,-1,-3856,0,0,0
19682 DATA 1799,-1,-3856,0,0,0,1799,-1
19683 DATA -3856,0,0,0,1799,-1,-3856,0
19684 DATA 0,0,771,-1,-7968,0,0,0
19685 DATA 771,-1,-7968,0,0,0,771,-2057
19686 DATA -7968,0,0,0,771,-2057,-7968,0
19687 DATA 0,0,771,-2057,-7968,0,0,0
19688 DATA 771,-2057,-7968,0,0,0,257,-7197
19689 DATA -16192,0,0,0,257,-7197,-16192,0
19690 DATA 0,0,257,-7197,-16192,0,0,0
19691 DATA 0,-7197,-32640,0,0,0,0,-7197
19692 DATA -32640,0,0,0,0,-15935,-32640,0
19693 DATA 0,3,1456,1516,1580,1716,256,0
19694 DATA 9,9,4,2,0,0,0,8
19695 DATA 0,0,32639,0,-1,-32640,-1,-32640
19696 DATA -1,-32640,32639,0,15934,0,7196,0
19697 DATA 2056,0,15934,0,256,0,8,10
19698 DATA 0,9,0,0,0,8,0,0
19699 DATA -13879,0,-28014,0,-28014,0,-28014,0
19700 DATA -13622,0,-30070,0,-30070,0,-30070,0
19701 DATA -30070,0,-11823,0,256,0,29,14
19702 DATA 4,2,0,0,0,8,0,0
19703 DATA 7967,-1,-1,-16192,8224,0,0,8224
19704 DATA 20046,0,0,4112,-30327,0,0,2056
19705 DATA -30327,8224,1028,2056,-30327,8224,1028,2056
19706 DATA -29042,8481,-15164,2056,-30327,8738,10023,2056
19707 DATA -30327,8738,9252,-30584,-30327,8738,9252,-30584
19708 DATA -29042,4369,-14393,2056,16448,0,0,4112
19709 DATA 8224,0,0,8224,7967,-1,-1,-16192
19710 DATA 256,0,14,10,6,4,0,0
19711 DATA 0,8,0,0,-1,-772,-1,-772
19712 DATA -1,-772,-7968,7196,-6169,-25444,-6169,-25444
19713 DATA -7968,7196,-1,-772,-1,-772,-1,-772
19714 DATA 2,1788,1820,1852,256,0,16,1
19715 DATA 0,0,0,12,0,0,0,0
19716 DATA -256,-256,-1,-1,256,0,16,1
19717 DATA 0,0,0,12,0,0,0,0
19718 DATA 255,255,-1,-1,256,0,16,1
19719 DATA 0,0,0,12,0,0,0,0
19720 DATA -1,-1,-1,-1,72,12298,12298,12298
19721 DATA 12853,12810,12593,14602,14346,13578,12554,12810
19722 DATA 11572,13834,14090,12298,12554,12298,14090,13322
19723 DATA 11569,2605,12554,14090,12298,11569,2605,12554
19724 DATA 12298,14090,11569,2605,12554,12853,12810,12593
19725 DATA 14602,3,11569,2560,28211,2610,14346,12597
19726 DATA 2610,2609,2608,2608,2610,2608,2608,2610
19727 DATA 14346,12597,2610,12850,2609,2608,2608,2608
19728 DATA 2608,2609,2617,13322,12597,2611,13322,12554
19729 DATA 12298,12298,11569,2614,14346,12810,14390,2609
19730 DATA 13578,12595,12810,12554,12298,12298,11569,2614
19731 DATA 14090,13066,12810,12298,12554,12810,12298,11575
19732 DATA 2605,12554,11569,2560,0,19504,2610,13360
19733 DATA 2617,13578,12810,12600,2608,2609,2610,2615
19734 DATA 2605,12554,12298,12298,13877,2609,2609,2608
19735 DATA 2615,2612,2605,12554,11569,2615,2608,2605
19736 DATA 12554,11569,2608,2615,2605,12554,11569,2609
19737 DATA 2609,2608,2608,2560,0,4144,2609,12298
19738 DATA 12594,2608,2609,12298,12594,2560,7981,12554
19739 DATA 11569,2608,2609,2608,2608,2608,2608,2608
19740 DATA 2611,2605,12554,11569,2605,12554,6,12298
19741 DATA 12298,12554
19742 DATA 21717
