100 :
110 REMark *************************************************************
120 REMark * The following two lines instruct Turbo how to compile EX4 *
130 REMark *************************************************************
140 :
150 TURBO_objfil 'ram1_EX4_TASK':TURBO_taskn 'EX4 v2.2':TURBO_objdat 100
160 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
170 :
180 REMark EX4_bas v2.2
190 REMark 9 DEC 01
200 :
205 REMark ***********************************************************
206 REMark * For SMSQ with PE we need to access #0 to activate it!!! *
207 REMark * Hence the spurious INK#0,GREEN%                         *
208 REMark ***********************************************************
210 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
220 :
230 REMark **************************************
240 REMark * wch% is used by M_SETUP, see later *
250 REMark **************************************
260 :
270 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
280 :
290 REMark **********************************************************************
300 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
310 REMark * and sets wd(r), the address(es) of window definition(s)            *
320 REMark **********************************************************************
330 :
340 REMark                            **************************************
350 wwd=M_SETUP(#wch%,wd(0),0):REMark * To produce the working definition  *
360 REMark                            **************************************
370 :
380 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
390 :
400 REMark ************************************************************
410 REMark * We must set a primary window here if this is COMPILED.   *
420 REMark * (PRPOS can be thought of as PRimary POSitioned).         *
430 REMark * If this is not COMPILED, BOUTL has set #0 as primary, so *
440 REMark * the window here must instead be "pulled down" as a       *
450 REMark * secondary window.                                        *
460 REMark ************************************************************
470 :
480 REMark *******************************************************
490 REMark * This is the repeat loop for reading the pointer and *
500 REMark * taking apropriate action                            *
510 REMark *******************************************************
520 REPeat lp
530  k=WRPTR(wwd)
540  r=255&&get_x%(k)
550  REMark ***************************************
560  REMark * r is the code extracted from k      *
570  REMark * 255 -> a loose item                 *
580  REMark * 254 -> an event                     *
590  REMark *                                     *
600  REMark * get_y%(k) is the bottom word of k   *
610  REMark * and is the item or event number     *
620  REMark ***************************************
630  SELect ON r
640   =255:REMark loose items
650     IF do_loose%(get_y%(k)):EXIT lp
660   =254:REMark event
670     IF do_event%(get_y%(k)):EXIT lp
680  END SELect
690 END REPeat lp
700 STOP
710 :
720 DEFine PROCedure finish
730  REMark *************************************************
740  REMark * BUNST unsets the working definition           *
750  REMark * BRCHP returns its area to the heap            *
760  REMark * CLOS closes the channel opened for the window *
770  REMark *************************************************
780  PRINT#0,"ENDED":BUNST wwd:BRCHP wwd:CLOS chid
790  REMark CLOSE#4
800         REMark ***************************************************
810  BRECHP:REMark * Returns the space used by the window definition *
820         REMark ***************************************************
830  STOP
840 END DEFine
850 :
860 DEFine FuNction do_loose%(num%)
870  REMark routine to do loose items
880  LOCal k,ans%
890  k=num%:ans%=0
900  REMark ********************************************
910  REMark * There are 3 loose items, numbered 0 to 2 *
920  REMark * 0 = the move icon                        *
930  REMark * 1 = "ESC"                                *
940  REMark * 2 = the sleep icon                       *
950  REMark ********************************************
960  SELect ON k
970   =1:finish:ans%=1
980   =0:mve
990   =2:Do_Sleep wwd,chid,wch%
1000  END SELect
1010                  REMark **********************************
1020  D_LDRW num%,wwd:REMark * Resets the item to "available" *
1030                  REMark **********************************
1040  RETurn ans%
1050 END DEFine
1060 :
1070 DEFine FuNction do_event%(num%)
1080  REMark ***********************************
1090  REMark * Each of these three events      *
1100  REMark * can also be accessed via the    *
1110  REMark * appropriate loose item          *
1120  REMark * 2 = quit, 8 = move, 32 = sleep  *
1130  REMark * When the action is done this    *
1140  REMark * returns 1 for stop, 0 for go on *
1150  REMark ***********************************
1160  LOCal as%
1170  as%=0
1180  IF 2&&num%:finish:as%=1
1190  IF 8&&num%:mve
1200  IF 32&&num%:Do_Sleep wwd,chid,wch%
1210  RETurn as%
1220 END DEFine
1230 :
1240 DEFine PROCedure mve
1250  REMark ***************************************
1260  REMark * On a move we must:                  *
1270  REMark *     1. reset #4                     *
1280  REMark *     2. set on/off -> OFF            *
1290  REMark *     3. reset the limits for drawing *
1300  REMark ***************************************
1310  BCHWIN wwd:REMark SET_CHANNEL#4,SWIN(0,1,wwd):wron%=1:on_off:set_lim
1320 END DEFine
1330 :
19600 DATA 2165
19601 DATA 10,17747,17162,21605,29556,2570,1862,1854
19602 DATA 1856,1,6,638,256,0,14,7
19603 DATA 6,3,0,12,0,36,0,60
19604 DATA -772,0,6168,0,13107,-16192,24672,-32640
19605 DATA -515,7196,771,-14136,0,7196,0,0
19606 DATA 0,0,0,0,0,0,0,0
19607 DATA 0,0,0,0,257,0,28,7
19608 DATA 6,3,0,12,0,64,0,116
19609 DATA -21761,-24336,0,0,515,-32576,0,0
19610 DATA 2575,2575,-24336,0,10300,0,-32576,0
19611 DATA -21761,-23821,515,-24336,0,2575,-24336,-32576
19612 DATA 0,0,515,-24336,0,0,0,0
19613 DATA 0,0,0,0,0,0,0,0
19614 DATA 0,0,0,0,0,0,0,0
19615 DATA 0,0,0,0,0,0,0,0
19616 DATA 545,0,14,7,6,3,0,12
19617 DATA 0,204,0,0,-2,-2,-2,-2
19618 DATA -2,-2,0,0,0,0,0,0
19619 DATA 0,0,0,0,0,-2,-2,0
19620 DATA 0,0,0,0,0,0,0,0
19621 DATA 0,0,-2,-2,0,0,-2,-2
19622 DATA -2,-2,0,0,0,0,0,-2
19623 DATA -2,0,0,0,0,0,-2,0
19624 DATA 0,0,0,0,-2,-2,-2,-2
19625 DATA -2,-2,0,-2,0,0,0,-2
19626 DATA -2,-2,0,0,0,0,0,0
19627 DATA -2,-2,-2,-2,0,0,-2,0
19628 DATA 0,0,0,0,0,0,0,0
19629 DATA 0,0,0,-2,-2,-2,0,0
19630 DATA 0,0,0,0,0,0,0,0
19631 DATA 0,0,0,0,0,0,0,0
19632 DATA 0,0,0,0,0,0,0,0
19633 DATA 0,0,0,0,0,0,0,0
19634 DATA 0,0,0,0,0,0,0,0
19635 DATA 0,0,0,0,0,0,0,0
19636 DATA 0,0,0,0,0,0,0,0
19637 DATA 0,0,0,0,0,0,0,0
19638 DATA 0,0,0,0,0,0,0,0
19639 DATA 0,0,0,0,0,0,0,0
19640 DATA 0,0,0,0,0,0,0,0
19641 DATA 0,0,0,0,0,0,0,0
19642 DATA 256,0,16,13,4,1,0,12
19643 DATA 0,60,0,108,0,0,3084,0
19644 DATA 3084,0,3084,0,3341,-32640,19789,-20304
19645 DATA 28013,-19276,28013,-19276,28527,-772,32639,-772
19646 DATA 16191,-772,16191,-1800,7967,-3856,3084,0
19647 DATA 7710,0,7710,0,7967,-32640,24415,-7968
19648 DATA -1,-772,-1,-258,-1,-258,-1,-258
19649 DATA -1,-258,32639,-258,32639,-772,16191,-1800
19650 DATA 257,0,32,13,4,1,0,12
19651 DATA 0,112,0,212,0,0,0,0
19652 DATA 0,-24336,0,0,0,-24336,0,0
19653 DATA 0,-24336,0,0,0,-23821,-32576,0
19654 DATA 8240,-23821,-30001,0,10300,-23821,-30001,8240
19655 DATA 10300,-23821,-30001,8240,10300,-21761,-21761,-24336
19656 DATA 10815,-21761,-21761,-24336,2575,-21761,-21761,-24336
19657 DATA 2575,-21761,-21761,-32576,515,-21761,-21761,0
19658 DATA 0,-3856,0,0,771,-772,0,0
19659 DATA 771,-772,0,0,771,-1,-16192,0
19660 DATA 13107,-1,-772,0,-1,-1,-1,-3856
19661 DATA -1,-1,-1,-772,-1,-1,-1,-772
19662 DATA -1,-1,-1,-772,-1,-1,-1,-772
19663 DATA 16191,-1,-1,-772,16191,-1,-1,-3856
19664 DATA 3855,-1,-1,-16192,545,0,15,13
19665 DATA 4,1,0,12,0,424,0,0
19666 DATA 0,0,0,0,0,0,0,0
19667 DATA 0,0,0,0,0,0,0,0
19668 DATA 0,0,0,0,-2,-2,0,0
19669 DATA 0,0,0,0,0,0,0,0
19670 DATA 0,0,0,0,-2,-2,0,0
19671 DATA 0,0,0,0,0,0,0,0
19672 DATA 0,0,0,0,-2,-2,0,0
19673 DATA 0,0,0,0,0,0,0,0
19674 DATA 0,0,0,0,-2,-2,0,-2
19675 DATA -2,0,0,0,0,0,0,0
19676 DATA 0,-2,0,0,-2,-2,0,-2
19677 DATA -2,0,-2,-2,0,0,0,0
19678 DATA 0,-2,-2,0,-2,-2,0,-2
19679 DATA -2,0,-2,-2,0,-2,0,0
19680 DATA 0,-2,-2,0,-2,-2,0,-2
19681 DATA -2,0,-2,-2,0,-2,0,0
19682 DATA 0,-2,-2,0,-2,-2,-2,-2
19683 DATA -2,-2,-2,-2,-2,-2,0,0
19684 DATA 0,-2,-2,-2,-2,-2,-2,-2
19685 DATA -2,-2,-2,-2,-2,-2,0,0
19686 DATA 0,0,-2,-2,-2,-2,-2,-2
19687 DATA -2,-2,-2,-2,-2,-2,0,0
19688 DATA 0,0,-2,-2,-2,-2,-2,-2
19689 DATA -2,-2,-2,-2,-2,0,0,0
19690 DATA 0,0,0,-2,-2,-2,-2,-2
19691 DATA -2,-2,-2,-2,0,0,0,0
19692 DATA 0,0,0,0,-1,-1,0,0
19693 DATA 0,0,0,0,0,0,0,0
19694 DATA 0,0,0,-1,-1,-1,-1,0
19695 DATA 0,0,0,0,0,0,0,0
19696 DATA 0,0,0,-1,-1,-1,-1,0
19697 DATA 0,0,0,0,0,0,0,0
19698 DATA 0,0,0,-1,-1,-1,-1,-1
19699 DATA -1,0,0,0,0,0,0,0
19700 DATA 0,-1,0,-1,-1,-1,-1,-1
19701 DATA -1,-1,-1,0,0,0,0,0
19702 DATA -1,-1,-1,-1,-1,-1,-1,-1
19703 DATA -1,-1,-1,-1,-1,-1,0,0
19704 DATA -1,-1,-1,-1,-1,-1,-1,-1
19705 DATA -1,-1,-1,-1,-1,-1,-1,0
19706 DATA -1,-1,-1,-1,-1,-1,-1,-1
19707 DATA -1,-1,-1,-1,-1,-1,-1,0
19708 DATA -1,-1,-1,-1,-1,-1,-1,-1
19709 DATA -1,-1,-1,-1,-1,-1,-1,0
19710 DATA -1,-1,-1,-1,-1,-1,-1,-1
19711 DATA -1,-1,-1,-1,-1,-1,-1,0
19712 DATA 0,-1,-1,-1,-1,-1,-1,-1
19713 DATA -1,-1,-1,-1,-1,-1,-1,0
19714 DATA 0,-1,-1,-1,-1,-1,-1,-1
19715 DATA -1,-1,-1,-1,-1,-1,0,0
19716 DATA 0,0,-1,-1,-1,-1,-1,-1
19717 DATA -1,-1,-1,-1,-1,0,0,0
19718 DATA -1,-1,82,12298,12554,11569,2610,13366
19719 DATA 2609,13617,2616,2615,2609,2609,2612,2610
19720 DATA 12592,2609,2609,2608,2615,2612,2605,12554
19721 DATA 11569,2615,2608,2605,12554,11569,2608,2615
19722 DATA 2605,12554,11569,2610,13366,2609,13617,2609
19723 DATA 13875,14388,2609,12810,25,12298,14392,2613
19724 DATA 14090,14132,2610,14602,12298,12554,13322,14090
19725 DATA 11569,2560,31026,2612,12298,12600,2610,2609
19726 DATA 2608,2608,2610,2613,2608,2612,12298,12600
19727 DATA 2609,12336,2609,2608,2608,2608,2611,2609
19728 DATA 2612,12298,12600,2610,12340,2609,2608,2608
19729 DATA 2610,2615,2610,2608,2608,2609,2605,14090
19730 DATA 12298,11569,2605,12554,12298,12598,13360,13322
19731 DATA 12594,2608,2608,2608,2608,2608,2608,2608
19732 DATA 2608,2608,2605,12554,11569,2605,12554,36
19733 DATA 12298,13368,2609,12298,12600,2609,12810,12298
19734 DATA 12595,12597,14388,2608,2609,2605,12554,11569
19735 DATA 2605,12554,7,11569,2605,12554,2560,0
19736 DATA 0,0,0
19737 DATA 4368
