1000 :
1010 REMark **********************************************************************
1020 REMark * The following two lines instruct Turbo how to compile EX5          *
1030 REMark **********************************************************************
1040 :
1050 TURBO_objfil 'ram1_EX5_TASK':TURBO_taskn 'EX5 v1.4':TURBO_objdat 100
1060 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
1070 :
1080 REMark EX5_bas v1.4
1090 REMark 9 DEC 01
1100                    REMark ***************************************************
1105 g_mxw:             REMark * This sets the maximum window size in _max_x%/y% *
1107                    REMark ***************************************************
1110 IF MODE%=8:MODE 4
1120 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
1130 :
1140 REMark                                 **************************************
1150 REMark                                 * wch% is used by M_SETUP, see later *
1160 REMark                                 **************************************
1170 :
1180 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
1190 :
1200 REMark **********************************************************************
1210 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
1220 REMark * and sets wd(r), the address(es) of window definition(s)            *
1230 REMark **********************************************************************
1240 :
1250                                       REMark ********************************
1260 OPEN#4,con:                           REMark * #4 is for use in writing     *
1270 flp=0:DIM flnme$(42):                 REMark * flp = 0 until flnme$ is set  *
1280 DIM q_title$(42),q_dfn$(42),q_ext$(6):REMark * Used in Set_Pars below       *
1285                                       REMark ********************************
1287 :
1290 REMark                     **************************************************
1300 REMark                     * We set the minimum window here.                *
1310 REMark                     * mmx% and mmy% are the minimum values needed.   *
1320 REMark                     * As in the resize operation, theses values come *
1330 REMark                     * from the window definition.                    *
1340 REMark                     **************************************************
1350 :
1360 mmx%=PEEK_W(wd(0)+48)&&4095:mmy%=PEEK_W(wd(0)+50)&&4095
1370 wwd=M_SETUP(#wch%,wd(0),mmx%*2^16+mmy%)
1380 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
1390 :
1400 REMark           ************************************************************
1410 REMark           * We must set a primary window here if this is COMPILED.   *
1420 REMark           * (PRPOS can be thought of as PRimary POSitioned)          *
1430 REMark           * If this is not COMPILED, BOUTL has set #0 as primary, so *
1440 REMark           * the window here must instead be "pulled down".           *
1450 REMark           ************************************************************
1460 REMark                                      *********************************
1470 SET_CHANNEL#4,SWIN(0,1,wwd):REMark          *  sets #4 to inf window 1      *
1480 REMark                                      *********************************
1490 :
1500 REMark                *******************************************************
1510 REMark                * This is the repeat loop for reading the pointer and *
1520 REMark                * taking apropriate action                            *
1530 REMark                *******************************************************
1540 :
1550 REPeat lp
1560  k=WRPTR(wwd):REMark k indicates whether loose item, event or application
1570  r=255&&get_x%(k)
1580  SELect ON r
1590   =255:REMark loose items
1600     IF do_loose%(get_y%(k)):EXIT lp
1610   =254:REMark event
1620     IF do_event%(get_y%(k)):EXIT lp
1630   =REMAINDER :REMark application window k
1640     do_app r,get_y%(k)
1650  END SELect
1660 END REPeat lp
1670 STOP
1680 :
1690 DEFine PROCedure finish
1700  CLS#4:PRINT#4,"ENDED":SUSPEND_TASK 75
1710                                             REMark **************************
1720  BUNST wwd:CLOS chid:                       REMark *  the window is removed *
1730                                             REMark **************************
1740  CLOSE#4:
1750                             REMark ******************************************
1760  BRECHP:                    REMark *  all space returned to the heap        *
1770                             REMark ******************************************
1780 END DEFine
1790 :
1800 DEFine FuNction do_loose%(num)
1810                         REMark  *********************************************
1820                         REMark  * routine to do loose items                 *
1830                         REMark  * this returns 1 for "finished" else 0      *
1840                         REMark  *  the five loose items are 0 = move sprite *
1850                         REMark  *                           1 = size sprite *
1860                         REMark  *                           2 = ESC         *
1870                         REMark  *                           3 = Zzz sprite  *
1880                         REMark  *                           4 = Pick        *
1890                         REMark  *********************************************
1900  LOCal ov%,nym
1910  ov%=0:nym=num:REMark Don't use parameter for SELect
1920  SELect ON nym
1930   =0:mve1
1940   =1:do_size
1950   =2:finish:RETurn 1
1960   =3:Do_Sleep wwd,chid,wch%: SET_CHANNEL#4,SWIN(0,1,wwd):prinf
1970   =4:Set_Pars:flnme$=FILE_SELECT$("Choose a file",q_dfn$,"ram1_",q_ext$):flp=1
1980                                  REMark  ************************************
1990    prinf       :                 REMark  * Prints the filename              *
2000                                  REMark  ************************************
2020  END SELect
2030                                  REMark  ************************************
2040  D_LDRW num,wwd:                 REMark  * Makes loose item 'available'     *
2050                                  REMark  ************************************
2060  RETurn ov%
2070 END DEFine
2080 :
2090 DEFine FuNction do_event%(num%)
2100  REMark                                 *************************************
2110  REMark                                 * The events Sleep - CTRL/F1        *
2120  REMark                                 *             Move - CTRL/F4        *
2130  REMark                                 *             Size - CTRL/F3        *
2140  REMark                                 *           Cancel - ESC            *
2150  REMark                                 * are all dealt with by loose items *
2160  REMark                                 * so this routine is not needed.    *
2165  REMark                                 *************************************
2170 END DEFine
2180 :
2190 DEFine PROCedure do_app(wind%,num%)
2200  REMark                                     *********************************
2210  REMark                                     * to do the menu item no num%   *
2220  REMark                                     * in window number wind%        *
2230  REMark                                     * no action need be taken here  *
2240  REMark                                     *********************************
2250 :
2260 END DEFine
2270 :
2280 DEFine PROCedure mve1
2290  REMark to move window
2300  BCHWIN wwd
2310  SET_CHANNEL#4,SWIN(0,1,wwd)
2320 END DEFine
2330 :
2340 DEFine PROCedure prinf
2350  LOCal a$(30)
2360  REMark                            ******************************************
2370  REMark                            * this prints to inf 1                   *
2380  REMark                            ******************************************
2390 :
2400  IF flp=0
2410   a$="No file picked yet"
2420  ELSE :IF flnme$="":a$="No file picked":ELSE a$="File picked:"
2430  END IF
2440  USE 4:CLS:PAPER BLACK%:OVER 0:INK WHITE%
2450  PRINT a$
2460  INK GREEN%
2470  AT 2,1:PRINT flnme$
2480  USE
2490 END DEFine
2500 :
2510 DEFine PROCedure do_size
2520  LOCal mv,xmv%,ymv%,newx%,newy%,optr,xz%,yz%
2530                       REMark ************************************************
2540                       REMark * The value to be used for PRPOS/PULLD is the  *
2550                       REMark * current window position plus its 'origin'    *
2560                       REMark * plus the old size minus the new.             *
2570                       REMark * The first comes from $24 of the working      *
2580                       REMark * definition (wwd), the second from the long   *
2590                       REMark * word at byte 4 of the window definition      *
2600                       REMark * whose address is given in both wd(0) and     *
2610                       REMark * PEEK_L(wwd+4), and the third from wwd+$20.   *
2615                       REMark * The fourth will be found later and           *
2617                       REMark * subtracted from the total so far - optr.     *
2620                       REMark ************************************************
2630  optr=PEEK_L(wwd+36)+PEEK_L(wd(0)+4)+PEEK_L(wwd+32)
2640                       REMark            *************************************
2650  mv=BCHSZ(wwd):       REMark            * mv is the reduction in size (x/y) *
2660                       REMark            *************************************
2670  xmv%=get_x%(mv):ymv%=get_y%(mv)
2680                      REMark *************************************************
2690                      REMark * We now have to check that the new size is     *
2700                      REMark * within reasonable limits. It must be no       *
2710                      REMark * bigger than the maximum in the window         *
2720                      REMark * definition. It must be no smaller than the    *
2730                      REMark * minimum size for this window layout.          *
2740                      REMark * This size is used in M_SETUP to arrive at the *
2750                      REMark * actual size.                                  *
2760                      REMark * PEEK_L(wwd+32) is the current window size.    *
2770                      REMark * PEEK_L(wd(0)+$30) is the minimum size for the *
2780                      REMark * first window layout. Since this is variable   *
2790                      REMark * we must eliminate the scaling flag ($4000)    *
2800                      REMark * for both x and y values.                      *
2810                      REMark * PEEK_L(PEEK_L(wwd+4)) is the maximum size of  *
2820                      REMark * window.                                       *
2830                      REMark * Then newx% must be made even (by ev%).        *
2835                      REMark * Finally we must see that the size will allow  *
2837                      REMark * space for shadow and border and still fit     *
2838                      REMark * into the current maximum screen size.         *
2840                      REMark *************************************************
2850 :
2855  xz%=_max_x%-4*PEEK(wwd+41)-4*PEEK_W(wwd+42):yz%=_max_y%-3*PEEK(wwd+41)-2*PEEK_W(wwd+42)
2860  newx%=min%(xz%,ev%(min%(PEEK_W(PEEK_L(wwd+4)),max%(PEEK_W(wd(0)+48)&&4095,PEEK_W(wwd+32)-xmv%))))
2870  newy%=min%(yz%,min%(PEEK_W(PEEK_L(wwd+4)+2),max%(PEEK_W(wd(0)+50)&&4095,PEEK_W(wwd+34)-ymv%)))
2875  mv=newx%*2^16+newy%
2880 :
2890                  REMark *****************************************************
2900                  REMark * BUNST unsets the working definition and throws    *
2910                  REMark * away the window if NOT COMPILED.                  *
2920                  REMark * BRCHP returns its area to the heap.               *
2930                  REMark * CLOS closes the channel opened if not COMPILED.   *
2940                  REMark * M_SETUP sets up the new working definition and    *
2950                  REMark * gives us its address (in wwd).                    *
2960                  REMark * M_PRPOS throws away the old window and sets up    *
2970                  REMark * a new one. M_PULLD pulls down a secondary window. *
2980                  REMark * All that remains is to reset #4.                  *
2990                  REMark *****************************************************
2995 :
3000  BUNST wwd:BRCHP wwd:IF NOT COMPILED:CLOS chid
3015  wwd=M_SETUP(#wch%,wd(0),newx%*2^16+newy%)
3025  IF COMPILED:chid=M_PRPOS(wwd,optr-mv):ELSE :chid=M_PULLD(wwd,optr-mv)
3030  SET_CHANNEL#4,SWIN(0,1,wwd):prinf
3040 END DEFine
3050 :
3060 DEFine PROCedure Set_Pars
3070  REMark                                          ****************************
3080  REMark                                          * This illustrates the use *
3090  REMark                                          * of the Qmenu extras:     *
3100  REMark                                          *   READ_STRING$ and       *
3110  REMark                                          *   ITEM_SELECT            *
3120  REMark                                          ****************************
3130  LOCal cho
3140  cho=ITEM_SELECT("To Set Filename and Ext","Pick ESC -> none","Filename only","Ext only","Both")
3150  SELect ON cho
3160   =0:q_dfn$="":q_ext$=""
3170   =1:ch_fl
3180   =2:ch_ex
3190   =3:ch_fl:ch_ex
3200  END SELect
3210 END DEFine
3220 :
3230 DEFine PROCedure ch_fl
3240  q_dfn$=READ_STRING$("Initial Filename",,"Print the filename:")
3250 END DEFine
3260 :
3270 DEFine PROCedure ch_ex
3280   q_ext$=READ_STRING$("Tailored EXT",,"Print up to 6 characters:")
3290 END DEFine
3300 :
3310 REMark               ********************************************************
3320 REMark               * The following DATA lines contain all the             *
3330 REMark               * information needed to set up the windows in EX1.     *
3340 REMark               * This includes the window sizes, the colours, and     *
3350 REMark               * sprites wanted. It also contains the sprites, blobs, *
3360 REMark               * or patterns themselves. All this is unravelled and   *
3370 REMark               * set in the window definitions by Set_Win.            *
3380 REMark               ********************************************************
3390 :
3400 DEFine PROCedure quse
3410  LOCal a$(2)
3420  OPEN#20,con
3430  a$=INKEY$(#20,-1)
3440  CLOSE#20
3450 END DEFine
3460 :
19600 DATA 2316
19601 DATA 40,17747,17162,21605,29556,8273,28005,28277
19602 DATA 2640,26979,27402,20079,8294,26988,25888,28777
19603 DATA 25451,25956,8313,25972,2570,1862,1854,1856
19604 DATA 1,6,1222,256,0,16,13,4
19605 DATA 1,0,12,0,60,0,108,0
19606 DATA 0,3084,0,3084,0,3084,0,3341
19607 DATA -32640,19789,-20304,28013,-19276,28013,-19276,28527
19608 DATA -772,32639,-772,16191,-772,16191,-1800,7967
19609 DATA -3856,3084,0,7710,0,7710,0,7967
19610 DATA -32640,24415,-7968,-1,-772,-1,-258,-1
19611 DATA -258,-1,-258,-1,-258,32639,-258,32639
19612 DATA -772,16191,-1800,257,0,32,13,4
19613 DATA 1,0,12,0,112,0,212,0
19614 DATA 0,0,0,0,-24336,0,0,0
19615 DATA -24336,0,0,0,-24336,0,0,0
19616 DATA -23821,-32576,0,8240,-23821,-30001,0,10300
19617 DATA -23821,-30001,8240,10300,-23821,-30001,8240,10300
19618 DATA -21761,-21761,-24336,10815,-21761,-21761,-24336,2575
19619 DATA -21761,-21761,-24336,2575,-21761,-21761,-32576,515
19620 DATA -21761,-21761,0,0,-3856,0,0,771
19621 DATA -772,0,0,771,-772,0,0,771
19622 DATA -1,-16192,0,13107,-1,-772,0,-1
19623 DATA -1,-1,-3856,-1,-1,-1,-772,-1
19624 DATA -1,-1,-772,-1,-1,-1,-772,-1
19625 DATA -1,-1,-772,16191,-1,-1,-772,16191
19626 DATA -1,-1,-3856,3855,-1,-1,-16192,545
19627 DATA 0,15,13,4,1,0,12,0
19628 DATA 424,0,0,0,0,0,0,0
19629 DATA 0,0,0,0,0,0,0,0
19630 DATA 0,0,0,0,0,0,0,-2
19631 DATA -2,0,0,0,0,0,0,0
19632 DATA 0,0,0,0,0,0,0,-2
19633 DATA -2,0,0,0,0,0,0,0
19634 DATA 0,0,0,0,0,0,0,-2
19635 DATA -2,0,0,0,0,0,0,0
19636 DATA 0,0,0,0,0,0,0,-2
19637 DATA -2,0,-2,-2,0,0,0,0
19638 DATA 0,0,0,0,-2,0,0,-2
19639 DATA -2,0,-2,-2,0,-2,-2,0
19640 DATA 0,0,0,0,-2,-2,0,-2
19641 DATA -2,0,-2,-2,0,-2,-2,0
19642 DATA -2,0,0,0,-2,-2,0,-2
19643 DATA -2,0,-2,-2,0,-2,-2,0
19644 DATA -2,0,0,0,-2,-2,0,-2
19645 DATA -2,-2,-2,-2,-2,-2,-2,-2
19646 DATA -2,0,0,0,-2,-2,-2,-2
19647 DATA -2,-2,-2,-2,-2,-2,-2,-2
19648 DATA -2,0,0,0,0,-2,-2,-2
19649 DATA -2,-2,-2,-2,-2,-2,-2,-2
19650 DATA -2,0,0,0,0,-2,-2,-2
19651 DATA -2,-2,-2,-2,-2,-2,-2,-2
19652 DATA 0,0,0,0,0,0,-2,-2
19653 DATA -2,-2,-2,-2,-2,-2,-2,0
19654 DATA 0,0,0,0,0,0,0,-1
19655 DATA -1,0,0,0,0,0,0,0
19656 DATA 0,0,0,0,0,0,-1,-1
19657 DATA -1,-1,0,0,0,0,0,0
19658 DATA 0,0,0,0,0,0,-1,-1
19659 DATA -1,-1,0,0,0,0,0,0
19660 DATA 0,0,0,0,0,0,-1,-1
19661 DATA -1,-1,-1,-1,0,0,0,0
19662 DATA 0,0,0,0,-1,0,-1,-1
19663 DATA -1,-1,-1,-1,-1,-1,0,0
19664 DATA 0,0,0,-1,-1,-1,-1,-1
19665 DATA -1,-1,-1,-1,-1,-1,-1,-1
19666 DATA -1,0,0,-1,-1,-1,-1,-1
19667 DATA -1,-1,-1,-1,-1,-1,-1,-1
19668 DATA -1,-1,0,-1,-1,-1,-1,-1
19669 DATA -1,-1,-1,-1,-1,-1,-1,-1
19670 DATA -1,-1,0,-1,-1,-1,-1,-1
19671 DATA -1,-1,-1,-1,-1,-1,-1,-1
19672 DATA -1,-1,0,-1,-1,-1,-1,-1
19673 DATA -1,-1,-1,-1,-1,-1,-1,-1
19674 DATA -1,-1,0,0,-1,-1,-1,-1
19675 DATA -1,-1,-1,-1,-1,-1,-1,-1
19676 DATA -1,-1,0,0,-1,-1,-1,-1
19677 DATA -1,-1,-1,-1,-1,-1,-1,-1
19678 DATA -1,0,0,0,0,-1,-1,-1
19679 DATA -1,-1,-1,-1,-1,-1,-1,-1
19680 DATA 0,0,0,256,0,14,7,6
19681 DATA 3,0,12,0,36,0,60,-772
19682 DATA 0,6168,0,13107,-16192,24672,-32640,-515
19683 DATA 7196,771,-14136,0,7196,0,0,0
19684 DATA 0,0,0,0,0,0,0,0
19685 DATA 0,0,0,257,0,28,7,6
19686 DATA 3,0,12,0,64,0,116,-21761
19687 DATA -24336,0,0,515,-32576,0,0,2575
19688 DATA 2575,-24336,0,10300,0,-32576,0,-21761
19689 DATA -23821,515,-24336,0,2575,-24336,-32576,0
19690 DATA 0,515,-24336,0,0,0,0,0
19691 DATA 0,0,0,0,0,0,0,0
19692 DATA 0,0,0,0,0,0,0,0
19693 DATA 0,0,0,0,0,0,0,545
19694 DATA 0,14,7,6,3,0,12,0
19695 DATA 204,0,0,-2,-2,-2,-2,-2
19696 DATA -2,0,0,0,0,0,0,0
19697 DATA 0,0,0,0,-2,-2,0,0
19698 DATA 0,0,0,0,0,0,0,0
19699 DATA 0,-2,-2,0,0,-2,-2,-2
19700 DATA -2,0,0,0,0,0,-2,-2
19701 DATA 0,0,0,0,0,-2,0,0
19702 DATA 0,0,0,-2,-2,-2,-2,-2
19703 DATA -2,0,-2,0,0,0,-2,-2
19704 DATA -2,0,0,0,0,0,0,-2
19705 DATA -2,-2,-2,0,0,-2,0,0
19706 DATA 0,0,0,0,0,0,0,0
19707 DATA 0,0,-2,-2,-2,0,0,0
19708 DATA 0,0,0,0,0,0,0,0
19709 DATA 0,0,0,0,0,0,0,0
19710 DATA 0,0,0,0,0,0,0,0
19711 DATA 0,0,0,0,0,0,0,0
19712 DATA 0,0,0,0,0,0,0,0
19713 DATA 0,0,0,0,0,0,0,0
19714 DATA 0,0,0,0,0,0,0,0
19715 DATA 0,0,0,0,0,0,0,0
19716 DATA 0,0,0,0,0,0,0,0
19717 DATA 0,0,0,0,0,0,0,0
19718 DATA 0,0,0,0,0,0,0,0
19719 DATA 0,0,0,0,0,0,0,-1
19720 DATA -1,87,12298,12554,11569,2617,14646,2612
19721 DATA 14649,2609,12810,14602,12554,12554,13322,12852
19722 DATA 12810,12298,12554,12298,14090,13322,11569,2605
19723 DATA 12554,14090,12298,11569,2605,12554,12298,14090
19724 DATA 11569,2605,12554,12598,14390,13322,12598,13616
19725 DATA 13322,12598,13112,13322,12594,2560,12849,2609
19726 DATA 13879,12594,2609,13834,14134,2609,2608,2609
19727 DATA 2612,2610,2609,13879,12344,2611,13322,14134
19728 DATA 2613,13322,12298,12554,13322,12298,11569,2560
19729 DATA -19916,2611,13322,12856,2610,2609,2608,2608
19730 DATA 2610,2613,2608,2611,13322,12856,2611,14346
19731 DATA 12554,12298,12298,12810,13834,12554,13108,2610
19732 DATA 14346,12598,14386,14346,12554,12298,12298,12298
19733 DATA 13066,12810,13108,2610,14346,12598,14137,12810
19734 DATA 12554,12298,12298,12810,14090,13066,12598,14129
19735 DATA 13834,12592,2615,13322,12601,2608,2608,2605
19736 DATA 12554,14384,2612,2609,2608,2610,2610,2605
19737 DATA 14090,11576,2609,2605,12554,11569,2608,2609
19738 DATA 13876,12340,2609,12810,12298,12298,12298,12298
19739 DATA 12298,12298,12298,12298,12298,11569,2605,12554
19740 DATA 11569,2560,18224,2614,12298,12592,2609,13108
19741 DATA 2610,2608,2612,13624,14133,12810,12298,12554
19742 DATA 11569,2605,12554,11569,2608,2609,12344,2609
19743 DATA 12298,12298,12298,12298,13365,14391,13618,2608
19744 DATA 2611,2605,12554,11569,2605,12554,6,11569
19745 DATA 2605,12554,0,0,0,0
19746 DATA 38396
