1000 :
1010 REMark *************************************************************
1020 REMark * The following two lines instruct Turbo how to compile EX0 *
1030 REMark *************************************************************
1040 :
1050 TURBO_objfil 'ram1_EX0_TASK':TURBO_taskn 'EX0 v1.4':TURBO_objdat 100
1060 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
1070 :
1080 REMark EX0_bas v1.4
1090 REMark 10 AUG 02
1100 :
1110 IF MODE%=8:MODE 4
1120 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
1130 :
1140 REMark **************************************
1150 REMark * wch% is used by M_SETUP, see later *
1160 REMark **************************************
1170 :
1180 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
1190 :
1200 REMark **********************************************************************
1210 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
1220 REMark * and sets wd(r), the address(es) of window definition(s)            *
1230 REMark **********************************************************************
1240 :
1250 REMark                            **************************************
1260 wwd=M_SETUP(#wch%,wd(0),0):REMark * To produce the working definition  *
1270 REMark                            **************************************
1280 :
1290 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
1300 :
1310 REMark ************************************************************
1320 REMark * We must set a primary window here if this is COMPILED.   *
1330 REMark *    (PRPOS can be thought of as PRimary POSitioned).      *
1340 REMark * If this is not COMPILED, BOUTL has set #0 as primary, so *
1350 REMark *    the window here must instead be "pulled down" as a    *
1360 REMark *                    secondary window.                     *
1370 REMark ************************************************************
1380 :
1390 REMark *******************************************************
1400 REMark * This is the repeat loop for reading the pointer and *
1410 REMark *          taking appropriate action                  *
1420 REMark *******************************************************
1430 REPeat lp
1440  k=WRPTR(wwd)
1450  r=255&&get_x%(k)
1460  REMark ***************************************
1470  REMark *   r is the code extracted from k    *
1480  REMark *   255 -> a loose item               *
1490  REMark *   254 -> an event                   *
1500  REMark * otherwise the number of app. window *
1510  REMark *                                     *
1520  REMark *  get_y%(k) is the bottom word of k  *
1530  REMark *   and is the item or event number   *
1540  REMark ***************************************
1550  SELect ON r
1560   =255:REMark loose items
1570     IF do_loose%(get_y%(k)):EXIT lp
1580   =254:REMark event
1590     IF do_event%(get_y%(k)):EXIT lp
1600   =REMAINDER :REMark application window r
1610     IF do_app%(r,get_y%(k)):EXIT lp
1620  END SELect
1630 END REPeat lp
1640 STOP
1650 :
1660 DEFine PROCedure finish
1670  REMark *************************************************
1680  REMark * BUNST unsets the working definition           *
1690  REMark * BRCHP returns its area to the heap            *
1700  REMark * CLOS closes the channel opened for the window *
1710  REMark *************************************************
1720  PRINT#0,"ENDED":BUNST wwd:BRCHP wwd:CLOS chid
1730 :
1740         REMark ***************************************************
1750  BRECHP:REMark * Returns the space used by the window definition *
1760         REMark ***************************************************
1770  STOP
1780 END DEFine
1790 :
1800 DEFine FuNction do_loose%(num%)
1810  REMark routine to do loose items
1820  LOCal k,ans%
1830  k=num%:ans%=0
1840  REMark ********************************************
1850  REMark * There are 4 loose items, numbered 0 to 3 *
1860  REMark * 0 = the move icon                        *
1870  REMark * 1 = the size icon                        *
1880  REMark * 2 = the sleep icon                       *
1890  REMark * 3 = "ESC"                                *
1900  REMark ********************************************
1910  SELect ON k
1920   =3:finish:ans%=1
1930   =1:do_size
1940   =0:mve
1950   =2:Do_Sleep wwd,chid,wch%
1960  END SELect
1970                             REMark **********************************
1980  IF NOT k=3:D_LDRW num%,wwd:REMark * Resets the item to "available" *
1990                             REMark **********************************
2000  RETurn ans%
2010 END DEFine
2020 :
2030 DEFine FuNction do_event%(num%)
2040  REMark ***********************************
2050  REMark *    Each of these four events    *
2060  REMark *  can also be accessed via the   *
2070  REMark *     appropriate loose item      *
2080  REMark * 2 = quit, 8 = move, 16 = resize *
2090  REMark *        and 32 = sleep.          *
2100  REMark *  When the action is done this   *
2110  REMark * returns 1 for stop, 0 for go on *
2120  REMark ***********************************
2130  LOCal as%
2140  as%=0
2150  IF 2&&num%:finish:as%=1
2160  IF 8&&num%:mve
2170  IF 16&&num%:do_size
2180  IF 32&&num%:Do_Sleep wwd,chid,wch%
2190  RETurn as%
2200 END DEFine
2210 :
2220 DEFine FuNction do_app%(wind%,num%)
2230  RETurn 0:REMark "go on"
2240 END DEFine
2250 :
2260 DEFine PROCedure do_size
2270  LOCal mv,xmv%,ymv%,newx%,newy%,optr
2280  REMark ************************************************
2290  REMark * optr is the value to be used for PRPOS/PULLD *
2300  REMark *  It is the current window position plus its  *
2310  REMark *            "origin" plus its size.           *
2320  REMark *   The first comes from $24 of the working    *
2330  REMark *  definition (wwd) the second and third from  *
2340  REMark * the long words at 4 and $20 respectively of  *
2350  REMark * the window definition whose address is given *
2360  REMark *      at both wd(0) and PEEK_L(wwd+4).        *
2370  REMark                                                *
2380  REMark * Since the move icon is near the top left of  *
2390  REMark *   the window, we want to leave the bottom    *
2400  REMark * right corner as near its original position   *
2410  REMark *  as possible. We thus want to subtract the   *
2420  REMark * increase in size from the current "origin"   *
2430  REMark * position of the cursor. The increase is the  *
2440  REMark * current size less the new size. The value of *
2450  REMark * optr is adjusted later by subtracting the    *
2460  REMark *                 new size.                    *
2470  REMark ************************************************
2480  optr=PEEK_L(wwd+$24)+PEEK_L(wd(0)+4)+PEEK_L(wwd+$20)
2490                REMark *************************************
2500  mv=BCHSZ(wwd):REMark * mv is the reduction in size (x/y) *
2510                REMark *************************************
2520  xmv%=get_x%(mv):ymv%=get_y%(mv)
2530  REMark *************************************************
2540  REMark *   We now have to check that the new size is   *
2550  REMark *    within reasonable limits. It must be no    *
2560  REMark *     bigger than the maximum in the window     *
2570  REMark *  definition. It must be no smaller than the   *
2580  REMark *     minimum size for this window layout.      *
2590  REMark * This size is used in M_SETUP to arrive at the *
2600  REMark *                 actual size.                  *
2610  REMark *  PEEK_L(wwd+32) is the current window size.   *
2620  REMark * PEEK_L(wd(0)+$30) is the minimum size for the *
2630  REMark *  first window layout. Since this is variable  *
2640  REMark *  we must eliminate the scaling flag ($4000)   *
2650  REMark *          for both x and y values.             *
2660  REMark * PEEK_L(PEEK_L(wwd+4)) is the maximum size of  *
2670  REMark *                   window.                     *
2680  REMark *   Finally newx% must be made even (by ev%).   *
2690  REMark *************************************************
2700 :
2710  newx%=ev%(min%(PEEK_W(PEEK_L(wwd+4)),max%(PEEK_W(wd(0)+48)&&4095,PEEK_W(wwd+32)-xmv%)))
2720  newy%=min%(PEEK_W(PEEK_L(wwd+4)+2),max%(PEEK_W(wd(0)+50)&&4095,PEEK_W(wwd+34)-ymv%))
2730 :
2740  REMark *****************************************************
2750  REMark *  BUNST unsets the working definition and throws   *
2760  REMark *       away the window if NOT COMPILED.            *
2770  REMark *     BRCHP returns its area to the heap.           *
2780  REMark *  CLOS closes the channel opened if not COMPILED.  *
2790  REMark *  M_SETUP sets up the new working definition and   *
2800  REMark *       gives us its address (in wwd).              *
2810  REMark *  M_PRPOS throws away the old window and sets up   *
2820  REMark * a new one. M_PULLD pulls down a secondary window. *
2830  REMark *****************************************************
2840  BUNST wwd:BRCHP wwd:IF NOT COMPILED:CLOS chid
2850  mv=newx%*2^16+newy%
2860  wwd=M_SETUP(#wch%,wd(0),mv)
2870 REMark *********************************************
2880 REMark * We use optr - mv to keep the bottom right *
2890 REMark *            corner stationary.             *
2900 REMark *********************************************
2910  IF COMPILED:chid=M_PRPOS(wwd,optr-mv):ELSE :chid=M_PULLD(wwd,optr-mv)
2920 END DEFine
2930 :
2940 DEFine PROCedure mve
2950  BCHWIN wwd
2960 END DEFine
2970 :
19600 DATA 1164
19601 DATA 75,17747,17162,16961,21321,17235,2636,28527
19602 DATA 29541,8265,29797,27962,2592,8224,12320,15648
19603 DATA 19823,30309,2592,8224,12576,15648,21093,29545
19604 DATA 31333,2592,8224,12832,15648,21356,25957,28682
19605 DATA 8224,8243,8253,8261,30825,29706,2562,-31742
19606 DATA 31746,32256,0,1025,0,0,3584,1792
19607 DATA 1536,768,0,3072,0,9216,0,15612
19608 DATA -1024,24,6144,51,13248,-16288,24704,-32515
19609 DATA -740,7171,968,-14336,28,7168,0,0
19610 DATA 0,0,0,0,0,0,0,0
19611 DATA 0,0,0,1,256,0,7168,1792
19612 DATA 1536,768,0,3072,0,16384,0,29866
19613 DATA -96,-4096,0,2,896,-16384,0,10
19614 DATA 3850,4000,-4096,40,15360,128,-16384,170
19615 DATA -94,-3326,928,-4096,10,4000,-3968,-16384
19616 DATA 0,2,928,-4096,0,0,0,0
19617 DATA 0,0,0,0,0,0,0,0
19618 DATA 0,0,0,0,0,0,0,0
19619 DATA 0,0,0,0,0,0,0,2
19620 DATA 8448,0,3584,1792,1536,768,0,3072
19621 DATA 0,-13312,0,255,-257,-257,-257,-257
19622 DATA -257,-512,0,0,0,0,0,0
19623 DATA 0,0,0,0,255,-257,-512,0
19624 DATA 0,0,0,0,0,0,0,0
19625 DATA 0,255,-257,-512,0,255,-257,-257
19626 DATA -257,-512,0,0,0,0,255,-257
19627 DATA -512,0,0,0,0,255,-512,0
19628 DATA 0,0,0,255,-257,-257,-257,-257
19629 DATA -257,-512,255,-512,0,0,255,-257
19630 DATA -257,-512,0,0,0,0,0,255
19631 DATA -257,-257,-257,-512,0,255,-512,0
19632 DATA 0,0,0,0,0,0,0,0
19633 DATA 0,0,255,-257,-257,-512,0,0
19634 DATA 0,0,0,0,0,0,0,0
19635 DATA 0,0,0,0,0,0,0,0
19636 DATA 0,0,0,0,0,0,0,0
19637 DATA 0,0,0,0,0,0,0,0
19638 DATA 0,0,0,0,0,0,0,0
19639 DATA 0,0,0,0,0,0,0,0
19640 DATA 0,0,0,0,0,0,0,0
19641 DATA 0,0,0,0,0,0,0,0
19642 DATA 0,0,0,0,0,0,0,0
19643 DATA 0,0,0,0,0,0,0,0
19644 DATA 0,0,0,0,0,0,0,0
19645 DATA 0,0,0,0,0,0,0,255
19646 DATA -1,-256,22576,2609,2605,12554,13367,13834
19647 DATA 12601,12298,12592,2614,2609,2609,2612,2610
19648 DATA 13362,2605,12554,12554,12298,14090,13322,11569
19649 DATA 2605,12554,14090,12298,11569,2605,12554,12298
19650 DATA 14090,11569,2605,12554,12598,14130,12298,12598
19651 DATA 13618,12810,12598,13112,13322,12594,2560,12337
19652 DATA 2609,13878,12344,2609,14346,13622,2609,2608
19653 DATA 2609,2612,2610,2610,13624,2614,14602,13112
19654 DATA 2610,13834,12298,12554,13322,14090,11569,2560
19655 DATA -27341,2610,13322,12600,2610,2609,2608,2608
19656 DATA 2610,2613,2608,2610,13322,12600,2610,14346
19657 DATA 12554,12298,12298,12810,13834,12554,12852,2609
19658 DATA 14346,12598,13881,13322,12554,12298,12298,12810
19659 DATA 14090,12810,12852,2609,14346,12598,13878,14346
19660 DATA 12554,12298,12298,12298,13066,13066,12298,12298
19661 DATA 12810,11575,2605,14346,12298,11569,2605,12554
19662 DATA 12298,12598,13360,13322,12594,2608,2608,2608
19663 DATA 2608,2608,2608,2608,2608,2608,2605,12554
19664 DATA 11569,2605,12554,132,12298,13110,2609,12298
19665 DATA 14642,2612,2608,2610,13874,12596,13322,12298
19666 DATA 12554,11569,2605,12554,11569,2612,2614,13834
19667 DATA 12592,2608,2608,2608,2608,2614,13834,12592
19668 DATA 2608,2609,12810,12298,12298,14136,2609,12298
19669 DATA 12298,12850,2608,2608,2615,12810,12592,2608
19670 DATA 2611,12810,12298,12298,13878,2609,12298,12298
19671 DATA 13362,2608,2608,2612,2610,2611,2612,2613
19672 DATA 2614,2605,12554,11569,2605,12554,6,11569
19673 DATA 2605,12554,0,0,0,0
19674 DATA 43363
